package eu.jonahbauer.chat.server;

import eu.jonahbauer.chat.server.bot.ChatBotSupervisor;
import eu.jonahbauer.chat.server.management.impl.ChatBotManager;
import eu.jonahbauer.chat.server.management.impl.SocketManager;
import eu.jonahbauer.chat.server.socket.SocketSupervisor;

import java.io.IOException;
import java.util.concurrent.CountDownLatch;

public class Main {

    public static void main(String[] args) throws IOException, InterruptedException {
        // initialize ChatBotManager and SocketManager
        var _ = ChatBotManager.INSTANCE;
        var _ = SocketManager.INSTANCE;

        var config = Config.load();
        ChatBotSupervisor.INSTANCE.start(config);
        SocketSupervisor.INSTANCE.start(config);

        try {
            // keep main thread running
            new CountDownLatch(1).await();
        } catch (InterruptedException e) {
            SocketSupervisor.INSTANCE.stop();
            ChatBotSupervisor.INSTANCE.stop();
        }
    }
}